function [cl,w] = clustercoeff_watts(matrix)
% [cl,w] = clustercoeff_watts(matrix)
% clustering coefficient
% cl: average over all nodes
% w: local values for each node
%
% definition according to
% Watts & Strogatz, Nature, 1998
%
% Author: Marcus Kaiser  Date: 28.08.02

NODES=length(matrix);


    w=zeros(NODES,1);
    for i=1:NODES
     n = find(matrix(i,:)+matrix(:,i)');
     n_e = 0;
     l_n = length(n);
     for j=1:l_n
       [dummy,n_v,dummy2] = find(matrix(n(j),:));
       n_e = n_e + l_n + length(n_v) - length(union(n,n_v));
     end;
     if l_n>1
       w(i) = n_e/(l_n*(l_n-1));
     end;
    end;
    cl=mean(w);


return
